---
terraform-plan:
  image:
    name: hashicorp/terraform:latest
    entrypoint: [""]
  stage: plan
  before_script:
    - apk --no-cache add jq
    - alias convert_report="jq -r '([.resource_changes[]?.change.actions?]|flatten)|{\"create\":(map(select(.==\"create\"))|length),\"update\":(map(select(.==\"update\"))|length),\"delete\":(map(select(.==\"delete\"))|length)}'"
  script:
    - terraform init
    - terraform plan -out=plan.out
    - terraform show -json plan.out | convert_report > plan.json
  artifacts:
    reports:
      terraform: plan.json
